<?php
/*************************************************************************************/
/*                                                                                   */
/*      Plugin "Frais de port sur devis"                                       		 */
/*                                                                                   */
/*      Copyright (c) Franck Allimant, 2010		                                     */
/*		email : thelia@allimant.org		        	                             	 */
/*                                                                                   */
/*************************************************************************************/

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsTransports.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Panier.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Client.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Message.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Messagedesc.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Modules.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Mail.class.php");

class Portsurdevis extends PluginsTransports
{
	public $id;
	public $client;
	public $panier;
	public $date_panier;
	public $port;
	public $complet;
	public $token;

	public $panier_session;
	public $mod = false;

	const NOM_MSG_NOTIFICATION = 'tarif_port_disponible';
	const NOM_MSG_NOTIFICATION_ADMIN =  'demande_devis_port';

	const NOM_MODULE = 'portsurdevis';

	const TABLE = self::NOM_MODULE;

	const VERSION = '1.2.0';

	public $table = self::TABLE;

	public $bddvars = array('id', 'client', 'panier', 'date_panier', 'complet', 'port', 'token');

	public function __construct()
	{
		parent::__construct(self::NOM_MODULE);

		$this->panier_session = false;

		$this->mod = new Modules();
		$this->mod->charger('portsurdevis');
	}

	public function init()
	{
		$query = '
			CREATE TABLE  portsurdevis (
			id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
			client INT NOT NULL,
			panier TEXT NOT NULL,
			date_panier INT NOT NULL,
			complet INT NOT NULL DEFAULT 0,
			token TEXT NOT NULL,
			port FLOAT NOT NULL DEFAULT 0
		)';

		$this->query($query);

		$message = new Message();

		if (! $message->charger(self::NOM_MSG_NOTIFICATION)) {

			$message->nom = self::NOM_MSG_NOTIFICATION;

			$lastid = $message->add();

			$messagedesc = new Messagedesc();
			$messagedesc->message = $lastid;
			$messagedesc->intitule = 'Tarif de port disponible';
			$messagedesc->lang = 1;
			$messagedesc->titre = 'Les frais de port de votre commande sur __NOM_SITE__ sont disponibles';
			$messagedesc->chapo = "";

			$messagedesc->descriptiontext =
"Bonjour __CLIENT_PRENOM__ __CLIENT_NOM__,

les frais de port de votre commande du __DATE_PANIER__ sur __NOM_SITE__ sont maintenant disponibles.
Vous pouvez terminer votre commande en cliquant ici: __URL_CHARGER__

Vous pouvez aussi vous rendre sur votre compte __NOM_SITE__ à l'adresse suivante: __URL_SITE__/?fond=moncompte.

Cordialement,
L'équipe __NOM_SITE__.";

			$messagedesc->description =
"Bonjour __CLIENT_PRENOM__ __CLIENT_NOM__,<br />
<br />
les frais de port de votre commande du __DATE_PANIER__ sur <a href=\"__URL_SITE__\">__NOM_SITE__</a> sont maintenant disponibles.<br />
Vous pouvez terminer votre commande en <a href=\"__URL_CHARGER__\">cliquant ici</a>.<br />
<br />
Vous pouvez aussi vous rendre sur <a href=\"__URL_SITE__/?fond=moncompte\">votre compte __NOM_SITE__</a>.<br />
<br />
Cordialement,<br />
L'équipe __NOM_SITE__.";

			$messagedesc->add();
		}


		$message = new Message();

		if (! $message->charger(self::NOM_MSG_NOTIFICATION_ADMIN)) {

			$message->nom = self::NOM_MSG_NOTIFICATION_ADMIN;

			$lastid = $message->add();

			$messagedesc = new Messagedesc();
			$messagedesc->message = $lastid;
			$messagedesc->intitule = "Demande de devis de port";
			$messagedesc->lang = 1;
			$messagedesc->titre = "Nouvelle demande de devis de port sur __NOM_SITE__";
			$messagedesc->chapo = "";

			$messagedesc->descriptiontext =
"Bonjour,

Un de vos client vient de demander un devis de frais de port. Vous pouvez consulter son panier est estimer les frais de port
dans votre Back-Office, Modules -> Frais de port sur devis.

Bonne journée !";

			$messagedesc->description = str_replace("\n", "<br />\n", $messagedesc->descriptiontext);

			$messagedesc->add();
		}

	}

	public function destroy()
	{
		$this->query('DROP TABLE  portsurdevis');

		$message = new Message();

		if ($message->charger(self::NOM_MSG_NOTIFICATION))
			if (method_exists($message, 'supprimer'))
				$message->supprimer();
			else
				$message->delete();

		if ($message->charger(self::NOM_MSG_NOTIFICATION_ADMIN))
			if (method_exists($message, 'supprimer'))
				$message->supprimer();
			else
				$message->delete();
	}

	public function charger($idpanier)
	{
		return $this->getVars("select * from $this->table where id = ".$idpanier);
	}

	public function charger_token($token)
	{
		return $this->getVars("select * from $this->table where token = '$token'");
	}


	public function action()
	{
		$action = $_REQUEST['action'];
		$idclient = $_SESSION['navig']->client->id;

		if ($action == "psdcharger")
		{
			$token = $_REQUEST['idp'];

			if ($this->charger_token($token))
			{
				$cli = New Client();

				if ($cli->charger_id($this->client) )
				{
					$_SESSION['navig']->client = $cli;
					$_SESSION['navig']->connecte = 1;

					$_SESSION['navig']->panier = new Panier();
					$_SESSION['navig']->panier = $this->get_panier_session();
					$_SESSION['navig']->panier->idpanier = $this->id;

					redirige(urlfond("commande", "action=transport&id=".$this->mod->id."&idp=".$this->token));
				}
			}
		}
		else if ($action == 'transport')
		{
			if ($this->mod->id == $_REQUEST['id'])
			{
				if (! isset($_REQUEST['idp']))
				{
					// Enregistrer le panier
					$this->client = $idclient;
					$this->panier = serialize($_SESSION['navig']->panier);
					$this->date_panier = time();
					$this->complet = 0;
					$this->port = 0;
					$this->token = md5(time() . $this->panier);

					$idpanier = $this->add();

					// Mail à l'admin du site
					$message = new Message();
					$message->charger(self::NOM_MSG_NOTIFICATION_ADMIN);

					$messagedesc = new Messagedesc();
					$messagedesc->charger($message->id);

					Mail::envoyer(
							Variable::lire('nomsite'),	Variable::lire('emailcontact'),
							Variable::lire('nomsite'),	Variable::lire('emailcontact'),
							$this->substitution($messagedesc->titre),
							$this->substitution($messagedesc->description),
							$this->substitution($messagedesc->descriptiontext)
					);

					// Redirection vers la page d'explication
					redirige(urlfond('attentedevis', 'idp='.$this->token));
				}
			}
		}
	}

	public function aprescommande($commande)
	{
		if (isset($_SESSION['navig']->panier->idpanier))
		{
			$idpanier = intval($_SESSION['navig']->panier->idpanier);

			$this->id = $idpanier;
			$this->delete();
		}
	}

	public function boucle($texte, $args)
	{
		$complete = lireTag($args, 'complet');

		$res = '';

		$idclient = $_SESSION['navig']->client->id;

		if ($idclient != 0)
		{
			$query = "select * from $this->table where client=$idclient ";

			if ($complete != '') $query .= " and complet = " . ($complete ? '1' : '0');

			$query .= ' order by date_panier asc';

			$hdl = $this->query($query);

			while ($hdl && $panier = $this->fetch_object($hdl))
			{
				$pn = unserialize($panier->panier);

				$tmp = str_replace('#IDPANIER', $panier->id, $texte);
				$tmp = str_replace('#DATEPANIER', strftime('%d/%m/%Y à %H:%M', $panier->date_panier), $tmp);
				$tmp = str_replace('#MONTANTPANIER', $pn->total(), $tmp);
				$tmp = str_replace('#POIDSPANIER', $pn->poids(), $tmp);
				$tmp = str_replace('#PORT', $panier->port, $tmp);
				$tmp = str_replace('#COMPLETE', $panier->complet, $tmp);
				$tmp = str_replace('#URLCHARGER', urlfond('commande', "action=psdcharger&idp=".$panier->token), $tmp);

				$res .= $tmp;
			}
		}

		return $res;
	}

	public function calcule()
	{
		if (isset($_SESSION['navig']->panier->idpanier))
		{
			$this->charger($_SESSION['navig']->panier->idpanier);

			return $this->port;
		}

		return 0;
	}

	public function maj_port($idpanier, $port)
	{
		if ($this->charger($idpanier))
		{
			$this->complet = 1;
			$this->port = $port;

			$this->maj();

			$client = new Client();

			if ($client->charger_id($this->client))
			{

				$this->envoi_mail_commande_ok(
					$idpanier,
					$client,
					$client->email,
					$client->prenom . ' ' . $client->nom
				);

				$this->envoi_mail_commande_ok(
					$idpanier,
					$client,
					Variable::lire('emailcontact'),
					Variable::lire('nomsite')
				);
			}
		}
	}

	public function envoi_mail_commande_ok($idpanier, $client, $to, $to_nom)
	{
		if ($this->charger($idpanier))
		{
			$message = new Message();
			$message->charger(self::NOM_MSG_NOTIFICATION);

			$messagedesc = new Messagedesc();
			$messagedesc->charger($message->id);

			Mail::envoyer(
				$to_nom, $to,
				Variable::lire('nomsite'),	Variable::lire('emailcontact'),
				$this->substitution($messagedesc->titre, $client),
				$this->substitution($messagedesc->description, $client),
				$this->substitution($messagedesc->descriptiontext, $client)
			);
		}
	}

	private	function substitution($str, $client = false)
	{
        if (trim($str) == '') return '';

        $str = str_replace("__NOM_SITE__", Variable::lire('nomsite'), $str);
        $str = str_replace("__URL_SITE__", Variable::lire('urlsite'), $str);

        if ($client) {
			$str = str_replace("__CLIENT_ENTREPRISE__", $client->entreprise, $str);
			$str = str_replace("__CLIENT_SIRET__", $client->siret, $str);
			$str = str_replace("__CLIENT_NOM__", $client->nom, $str);
			$str = str_replace("__CLIENT_PRENOM__", $client->prenom, $str);
        }

		$str = str_replace('__URL_CHARGER__', urlfond('index', "action=psdcharger&idp=".$this->token), $str);

        $str = str_replace("__DATE_PANIER__", strftime('%d/%m/%Y à %H:%M', $this->date_panier), $str);
        $str = str_replace("__MONTANT_PANIER__", $this->get_panier_session()->total(), $str);
        $str = str_replace("__POIDS_PANIER__", $this->get_panier_session()->poids(), $str);
        $str = str_replace("__PORT__", $this->port, $str);
        $str = str_replace("__ID_PANIER__", $this->id, $str);

        return $str;
    }

    public function get_panier_session()
    {
    	if (! $this->panier_session)
    	{
    		$this->panier_session = unserialize($this->panier);
    	}

    	return $this->panier_session;
    }
}


?>
