<?php
/*************************************************************************************/
/*                                                                                   */
/*      Plugin "Frais de port sur devis"                                       		 */
/*                                                                                   */
/*      Copyright (c) Franck Allimant, CQFDev, 2010-2012                             */
/*		email : franck@cqfdev.fr		        	                             	 */
/*		web : www.cqfdev.fr		        	                             	         */
/*                                                                                   */
/*************************************************************************************/

include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/authplugins.php");
require_once(realpath(dirname(__FILE__)) . '/Portsurdevis.class.php');

autorisation(Portsurdevis::NOM_MODULE);

class PortsurdevisAdmin extends Portsurdevis {
    var $redirect;
    var $erreur;
    var $paniers;

    public function __construct()     {
        parent::__construct();

        $this->redirect = false;
        $this->erreur = false;
        $this->paniers = false;
    }

    public function maj_frais_de_port() {
    	$idpanier = intval($_REQUEST['idpanier']);
    	$port     = intval($_REQUEST['port']);

    	$this->maj_port($idpanier, $port);

    	$this->redirect = true;
    }

    public function delete_panier() {
    	$idpanier = intval($_REQUEST['idpanier']);

    	$this->id = $idpanier;
    	$this->delete();

    	$this->redirect = true;
    }

    public function prepare_page() {
    	$query = "select id from $this->table order by date_panier asc";

		$liste = $this->query($query);

		while($liste && $obj = $this->fetch_object($liste))
		{
			$psd = new Portsurdevis();
			$psd->charger($obj->id);

			$this->paniers[] = $psd;
		}
    }
}

// -- MAIN -------------------------------------------------------------------------------------

    $adm = new PortsurdevisAdmin();

    $command = $_REQUEST['_psd_commande'];

    switch($command)
    {
        case 'maj_frais_de_port' :
            $adm->maj_frais_de_port();
        break;

        case 'delete_panier' :
            $adm->delete_panier();
        break;
    }

    if ($adm->redirect)
    {
        ?>
        <script type="text/javascript">
            self.location = "module.php?nom=portsurdevis";
        </script>
        <?php

        exit();
    }

    $adm->prepare_page();
?>

<script type="text/javascript" src="../lib/jquery/jquery.js"></script>

<script type="text/javascript">

    function psd_check_form(zeform)
    {
    	var field = $(zeform.port);

    	if (field.val() == '' || isNaN(parseInt(field.val())))
    	{
    		alert("Vous devez indiquer un montant de port valide.");

    		field.focus();

    		return false;
    	}

    	return true;
     }

     function psd_check_delete(zeform)
     {
     	 if (confirm("Supprimer définitivement ce panier ?"))
     	 {
     	 	 $(zeform._psd_commande).val("delete_panier");

     	 	 return true;
     	 }

     	 return false;
     }
</script>

<div id="contenu_int">
    <p>
	    <a href="accueil.php" class="lien04">Accueil </a> <img src="gfx/suivant.gif" width="12" height="9" border="0" />
	    <a href="module_liste.php" class="lien04">Modules </a> <img src="gfx/suivant.gif" width="12" height="9" border="0" />
	    <a href="module.php?nom=<?php echo $adm::NOM_MODULE; ?>" class="lien04">Port sur devis v<?php echo $adm::VERSION; ?></a>
    </p>

    <div id="bloc_description" style="width: 100%">

		<div class="entete">
			<div class="titre">PANIERS EN ATTENTE DE DEVIS</div>
		</div>

        <table width="100%" cellpadding="5" cellspacing="0">
        <?php if ($adm->paniers === false) { ?>
        <tr class="claire">
        	<td>Il n'y a pas de panier en attente de devis de frais de port.</td>
        </tr>
        <?php } else { ?>
        <?php

        $style = 'fonce';

        foreach($adm->paniers as $panier)
        {
        	$style = ($style == 'claire' ? 'fonce' : 'claire');

        	$client = new Client();
        	$client->charger_id($panier->client);
        ?>
 			<tr class="<?php echo $style ?>">
 				<td>Client <a href="client_visualiser.php?ref=<?php echo $client->ref; ?>" target="_client"><?php echo $client->ref; ?></a>, panier du <?php echo strftime("%d/%m/%Y a %H:%M", $panier->date_panier); ?>, montant <?php echo $panier->get_panier_session()->total(); ?> &euro;, poids <?php echo $panier->get_panier_session()->poids(); ?> Kg</td>
				<td>
					<form id="psd_form">
						<input type="hidden" name="nom" value="portsurdevis" />
						<input type="hidden" name="_psd_commande" value="maj_frais_de_port" />
						<input type="hidden" name="idpanier" value="<?php echo $panier->id; ?>" />
						Frais: <input type="text" name="port" size="5" value="<?php echo $panier->port; ?>" /> &euro;
						<input type="submit" value="OK" onclick="return psd_check_form(this.form); "/>
						<input type="submit" value="Supprimer" onclick="return psd_check_delete(this.form); "/>
					</form>
				</td>
			</tr>

			<tr class="<?php echo $style ?>">
				<td colspan="2">

					<table width="100%" cellpadding="5" cellspacing="0">
					<tr class="<?php echo $style ?>">
						<th>Réf.</th>
						<th>Libellé</th>
						<th>Poids (Kg)</th>
						<th>Quantité</th>
						<th>Prix</th>
						<th>Total</th>
					</tr>
					<?php
						$pn = unserialize($panier->panier);

						foreach($pn->tabarticle as $art) {
							$prix = $art->produit->promo ? $art->produit->prix2 : $art->produit->prix;
						?>
							<tr class="<?php echo $style ?>">
								<td><?php echo $art->produit->ref ?></td>
								<td><?php echo $art->produitdesc->titre ?></td>
								<td><?php echo $art->produit->poids ?></td>
								<td><?php echo $art->quantite ?></td>
								<td><?php echo formatter_somme($prix) ?></td>
								<td><?php echo formatter_somme($prix * $art->quantite) ?></td>
							</tr>
						<?php } ?>
					</table>

				</td>
			</tr>
		  <?php } } ?>
       	 </table>
     </div>

	<div style="clear: both;"></div>

	<p style="clear: both; margin-top: 10px; color: #505050; font-size: 10px; text-align: left;">
		Plugin Thelia réalisé par <a href="http://www.cqfdev.fr" target="_blank">Franck Allimant, CQFDev</a>.
		Contact: <a href="http://www.cqfdev.fr" target="_blank">www.cqfdev.fr</a>
	</p>

</div>
